'////////////////////////////////////////////////////////////////
'///  FastAVR Basic Compiler by MICRODESIGN, www.FastAVR.com  ///
'///  Temperature measurement program, 0.1C res,              ///
'///  1820.bas                                                ///
'////////////////////////////////////////////////////////////////
$Device= 2313
$Stack = 32
$Clock = 3.6864
$Lcd   = PORTD.4, rs=PORTB.4, en=PORTB.5, 16, 4
$1Wire = PORTD.3
$Source= On

Dim T As Word
Dim d0 As Byte, d1 As Byte, d2 As Byte, d3 As Byte
Dim d4 As Byte, d5 As Byte, d6 As Byte, d7 As Byte
Dim crc As Byte

Declare Sub Read1820()
Declare Sub CalcTmp()

Lcd "DS1820 T="

Do
	If 1Wreset Then
		1Wwrite &hcc; &h44
		WaitMs 250
		1Wreset
		1Wwrite &hcc; &hbe
		Read1820()
	Else
		Locate 1,10: Lcd "---"
	End If
	WaitMs 200
Loop

'/////////////////////////////////////////////////////
Sub Read1820()

1Wread d0,9				' read all 9bytes
If Crc8(d0,9)=0 Then	' check Crc, if OK
	CalcTmp()			' calc temp
Else
	Locate 1,10: Lcd "CRC"
End If
End Sub

'/////////////////////////////////////////////////////
Sub CalcTmp()	' calc for 0.1C resolution
' T is 10 times greater (integer)

If d0.1 Then Decr d0	' if odd decrement
T=(50*d0-25+(100*(d7-d6))/d7)/10
Locate 1,10: Lcd T
End Sub
