'////////////////////////////////////////////////////////////////
'///  FastAVR Basic Compiler by MICRODESIGN, www.FastAVR.com  ///
'///  Demo for ADXL202 (STK-500) - ADXL202pre.bas             ///
'///  Rt2=560k, Cfilt=330n                                    ///
'///  X on PORTD.2, Y on PORTD.3                              ///
'////////////////////////////////////////////////////////////////
$Device   = 8515
$Stack    = 32
$Clock    = 7,3728
$Timer1   = Timer, Prescale=8
$Lcd      = PORTA.0, Rs=PORTA.5, En=PORTA.4, 20, 4
$LeadChar = " "
$Source   = On

Declare Interrupt Int0()
Declare Interrupt Int1()

Dim XT1 As Word, YT1 As Word, T2 As Word
Dim SumXT1 As Word, SumYT1 As Word, SumT2 As Word
Dim xt As Byte, yt As Byte
Dim x As Long, y As Long
Dim tmp As Byte

Dim PhaseT1 As Bit, PhaseT2 As Bit
Dim DataRdy As Bit

Const True=1, False=0
Const samp=8, Scale=1000
Const Xcal=296, Ycal=309

Lcd "ADXL202"

Int0 Rising
Int1 Rising

PhaseT1=True: PhaseT2=False

Enable Int0
Enable Interrupts

SumXT1=0: SumYT1=0: SumT2=0
Start Timer1

Do
	If DataRdy Then				' after measurement
		SumXT1=sumXT1+XT1		' making average
		SumYT1=sumYT1+YT1
		SumT2=SumT2+T2
		Incr tmp
		If tmp=samp Then		' N of samples for Avrg?
			XT1=SumXT1/samp		' calculate Avrg
			YT1=SumYT1/samp
			T2=Sumt2/samp
			x=Scale*XT1/T2		' this s K*g
			y=Scale*YT1/T2
			XT1=x-Xcal			' adjust middle point
			YT1=y-Ycal
			xt=XT1: yt=YT1		' force to Byte
			Locate 2,1: Lcd "X="; xt; " Y="; yt
			SumXT1=0: SumYT1=0: SumT2=0
			tmp=0
		End If
		DataRdy=False
	End If
Loop


'////////////////////////////////////////////////////////////////
Interrupt Int0(), Save 1		' X axe
If PhaseT2 Then					' end of T2
	t2=Timer1					' remember T2
	PhaseT1=True: PhaseT2=False	' enable next phase
	Disable Int0				' Y is next
	Enable Int1					' no X in next
Else							' T1 sequence
	If PhaseT1 Then				' start of T1
		Timer1=0				' reset timer
		Int0 Falling			' prepare for end of T1
		PhaseT1=False			' next phase
	Else						' end of T1
		xt1=Timer1				' so remember T1
		PhaseT2=True			' enable end of T2 waiting
		Int0 Rising				' it is on rising edge
	End If
End If
Reset Int1						' because flag was Set
End Interrupt

'////////////////////////////////////////////////////////////////
Interrupt Int1(), Save 1	' Y axe
If PhaseT1 Then
	Timer1=0
	Int1 Falling
	PhaseT1=False
Else
	yt1=Timer1
	Int1 Rising
	PhaseT1=True: PhaseT2=False
	Disable Int1
	Enable Int0
	DataRdy=True				' we have both axes 
End If
Reset Int0
End Interrupt
