'//////////////////////////////////////////////////////////
'///    FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///    Event counter           						///
'///	1(300ms) on PORTB.0 resets counts 	            ///
'///	1(300ms) on PORTB.1 increments counts           ///
'///	1 on both inputs: test display
'///	PowerFail on Int0 saves counts				    ///
'///	four disp on shift registers TPIC6595           ///
'//////////////////////////////////////////////////////////
$Device= 2313						' used device
$Stack = 32                			' stack size
$Clock = 3,6864						' used clock in MHz
$Key row=PORTB &h03, Hi, 90			' Keys on PORTD.0.1
$ShiftOut data=PORTB.2, clock=PORTB.4, 1
$Source= On
$LeadChar=":", Format(4.0)			' ":" is next to 9
$Def Strobe=PORTB.3
$Def Pfail=PORTD.2

Declare Sub Show()
Declare Sub Test()
Declare Interrupt Int0()

Dim s As String*4					' must be first (on &h60)
Dim n As Byte, m As Byte
Dim Count As Word
Dim Gen As Flash Byte

Set DDRB.3							' Strobe is Out 

n=ReadEE(1)
Count=MakeWord(ReadEE(2), n)		' restore Count
Show()								' shows Count
Int0 Falling
Enable Int0
Enable Interrupts
Do
	n=Key()							' pool inputs
	WaitMs 90						' we catch something
	If n=Key() Then					' wait and pool again
		If n Then					' if we have something
			Select Case n			' act according
				Case 1				' reset Command
					Count=0
				Case 2				' increment Comm
					Incr Count
				Case 3				' increment Comm
					Test()			' display test
			End Select
			Show()
			NoKey()					' wait for no sig
		End If
	End If
Loop

'/////////////////////////////////////////////////////
Sub Show()						' refresh display
s=Str(Count)
For n=&h60 To &h63				' four times
	ShiftOut(Gen(Peek(n)-48))	' load Shift register
Next
Set Strobe						' data out
Reset Strobe
End Sub

'/////////////////////////////////////////////////////
Sub Test()						' refresh display
For n=0 To 9					' all numbers
	For m=0 To 3				' to all digits
		ShiftOut(Gen(n))		' load Shift register
	Next
	Set Strobe					' data out
	Reset Strobe
	WaitMs 250
Next
End Sub

'/////////////////////////////////////////////////////
Interrupt Int0(), Save 1		' preserves Count
WriteEE(1, Count)
WriteEE(2, Msb(Count))
End Interrupt

'/////////////////////////////////////////////////////
Gen=&h3f,&h06,&h5b,&h4f,&h66,&h6d,&h7d,&h07,&h7f,&h6f,0
