'//////////////////////////////////////////////////////////
'///    FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///    FIFO.bas  - circular buffer                     ///
'///    Fifo.bas                      www.FastAVR.com   ///
'//////////////////////////////////////////////////////////
$Device= 2313				' used device
$Stack = 16                	' stack size
$Clock = 7.3728				' used clock
$Baud  = 9600
$Source= On

Dim Buff(16) As Byte		' Buff starts at &h60
Dim db As Byte
Dim Head As Byte, Tail As Byte
Dim n As Byte
Dim adr As Byte

Declare Interrupt Urxc()
Declare Function Fifo() As Byte

Const StartOfBuff=&h60
Const EndOfBuff  =&h70

Head=StartOfBuff			' pointer to the start of Buff
Tail=StartOfBuff			' pointer to the start of Buff
adr=&h80					' for test, we put chars here
Enable Interrupts
Enable Urxc					' receive complete interrupt
                                         
Do
	n=Fifo()           		' get new char from circ Buff
	If n Then				' if new char, then
		Print n
	End If
Loop

'//////////////////////////////////////////////////////////
Interrupt Urxc(), Save 1	' receive int
InputBin db					' new char
Poke(Tail, db)            	' put it on Tail
Incr Tail					' Tail is bigger now
If Tail=EndOfBuff Then		' if Tail is at the end of Buff
	Tail=StartOfBuff		' Tail to start of Buff again
End If
End Interrupt

'//////////////////////////////////////////////////////////
Function Fifo() As Byte		' read char from circ Buff
Local temp As Byte

If Head=Tail Then			' no chars waiting
	Return 0				' so, return empty
	Exit Function 			' end exit
End If                                            
temp=Peek(Head)				' else retreive next char  
Incr Head					' mov adr toward Tail
If Head=EndOfBuff Then		' are we at the end of Buff
	Head=StartOfBuff		' yes, so go to start
End If                     
Return temp					' return with new char
End Function
           