'////////////////////////////////////////////////////////////////////
'///  FastAVR Basic Compiler by MICRODESIGN,     www.FastAVR.com  ///
'///    8 channel SERVO using 7.3728 MHz                          ///
'///    Compare1A reload values:                                  ///
'///       115 - 1.0 ms                                           ///
'///       173 - 1.5 ms                                           ///
'///       231 - 2.0 ms           max=255=2.2 ms                  ///
'///  Serbo8.bas                                                  ///
'////////////////////////////////////////////////////////////////////
$Device= 2313				' used device
$Stack = 20                	' stack size
$Clock = 7.3728				' used clock in MHz
$Timer1=Timer, Prescale=64, CompareA=DisConnect, Clear
$Baud  =115200
$Source= On

Dim s1 As Byte,s2 As Byte,s3 As Byte,s4 As Byte
Dim s5 As Byte,s6 As Byte,s7 As Byte,s8 As Byte
Dim adr As Byte				' servo's address
Dim p As Byte				' PORTB output
Dim t As Byte               ' reload value
Dim tip As Byte
Dim adrx As Byte, rec As Byte

Declare Interrupt Oc1()
Declare Interrupt Urxc()

p=&h01						' first servo on bit 1
For adr=&h60 To &h67		' adr of servos data (s1, s2,..)
	Poke(adr, 173)			' init servos to mid possition
Next
PORTB=&hff
DDRB=&hff					' servos on PORTB
Start Timer1
Enable Oc1
Enable Urxc
Enable Interrupts

Do
	' bla bla
Loop

'//////////////////////////////////////////////////////////
Interrupt Oc1(), Save 1		' generate servos output
PORTB=p						' new value on PORTB
If adr=&h68 Then			' through all servos?
	adr=&h60				' yes, intit to servo1
End If     
t=Peek(adr)					' read reload value
Compare1A=t					' reload timer
Rotate(Left,1,p)			' prepare for next servo
Incr adr					' prepare for next servo
End Interrupt

'///////////////////////////////////////////////////////
Interrupt Urxc(), Save 1	' receiving two values
InputBin rec				' one by one				
If rec<8 Then               ' if first is 0-7
	adrx=&h60+rec			' is address of servo
Else
	Poke(adrx, rec)   		' else is servo value
End If
End Interrupt